/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.human.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.PrefectureUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.common.action.MosPHumanAction;
import jp.mosp.kintai.human.dto.MEmergencyDto;
import jp.mosp.kintai.human.dto.MKojinDto;
import jp.mosp.kintai.human.vo.HumanPersonalCardVo;

/**
 * @author yoshida
 *
 */
public class HumanPersonalCardAction extends MosPHumanAction {
	
	// コマンド
	/**
	 * 
	 */
	public static final String	CMD_HUMAN_PERSONAL_SELECT	= "H1030";
	private static final String	CMD_HUMAN_PERSONAL_UPDATE	= "H1033";
	
	// フィールド
	private MKojinDto			storedmKojinDto;
	private MEmergencyDto		storedmEmergencyDto;
	

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_HUMAN_PERSONAL_SELECT)) {
			// 表示(社員コードで情報を検索)
			select();
		} else if (cmd.equals(CMD_HUMAN_PERSONAL_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new HumanPersonalCardVo();
	}
	
	/**
	 * 初期処理
	 * @throws Exception	例外処理が発生した場合
	 */
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// HUMAN権限確認
		confirmHumanAuth();
		// VOの取得
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// 性別リスト取得
		vo.aryPltGender = getMosPCodeArray(CommonConst.TID_SEIBETSU);
		// 生年月日リスト取得
		final int former = 50;
		vo.aryPltBirthYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()), former, 1);
		vo.aryPltBirthMonth = StringUtil.getMonthArray();
		vo.aryPltBirthDay = StringUtil.getDayArray();
		// ボタン内容設定
		setListButton();
		// プルダウン設定 
		setPulldownList();
		// 機能ボタン設定
		setFunctionButton(false);
	}
	
	/**
	 * プルダウン設定
	 * @throws Exception	例外処理が発生した場合
	 */
	protected void setPulldownList() throws Exception {
		// VOの取得
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// 県リスト取得
		vo.aryPltPrefecture = PrefectureUtil.getPrefectureArray();
		// 血液型リスト
		vo.aryPltBloodType = getMosPCodeArray(CommonConst.TID_BLOOD_TYPE);
		// 給与区分
		vo.aryPltSalaryKb = getMosPCodeArray(CommonConst.TID_SALARY);
		// 税区分
		vo.aryPltTaxKb = getMosPCodeArray(CommonConst.TID_TAX);
		// 組合区分
		vo.aryPltUnionKb = getMosPCodeArray(CommonConst.TID_UNION);
		// 支払い区分
		vo.aryPltPaymentKb = getMosPCodeArray(CommonConst.TID_PAYMENT);
		// パート区分
		vo.aryPltPartKb = getMosPCodeArray(CommonConst.TID_PARTTIME);
	}
	
	@Override
	protected void select() throws Exception {
		// VOの取得
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// 選択社員コード取得
		String kCode = "";
		if (StringUtil.isNotNull(vo.getTxtChangeKCode())) {
			kCode = vo.getTxtChangeKCode();
		} else if (StringUtil.isNotNull(key1)) {
			kCode = key1;
		}
		// 人事基本情報取得
		getHumanKihonInfo(kCode);
		// 個人情報取得
		getHumanKojinInfo(kCode);
		// 緊急連絡先取得処理
		getHumanmEmergencyInfo(kCode);
		// 表示用人事基本情報設定
		vo.setLblKCode(kCode);
		vo.setLblKName(mKihonDto.getSimei());
		vo.setLblKKana(mKihonDto.getFurigana());
		// セッションにDTOをセット
		setStoredDto();
	}
	
	@Override
	protected void update() throws Exception {
		// VOの取得
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// セッション保持DTO取得
		getStoredDto();
		// パラメータの妥当性確認
		vo.validate();
		// 登録処理
		String message = regist();
		// コミット
		commit();
		// 人事基本情報取得
		getHumanKihonInfo(vo.getTxtChangeKCode());
		getHumanKojinInfo(vo.getTxtChangeKCode());
		getHumanmEmergencyInfo(vo.getTxtChangeKCode());
		// メッセージ設定
		vo.setMessage(message);
		// 表示用人事基本情報設定
		vo.setLblKCode(vo.getTxtChangeKCode());
		vo.setLblKName(mKihonDto.getSimei());
		vo.setLblKKana(mKihonDto.getFurigana());
		// セッションにDTOをセット
		setStoredDto();
	}
	
	/**
	 * 情報取得処理
	 * @param kCode 取得対象社員コード
	 * @throws Exception	例外処理が発生した場合
	 */
	private void getHumanKihonInfo(String kCode) throws Exception {
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// 人事基本情報取得
		findHumanBasisInfo(kCode, false);
		// 対象データ存在確認
		if (mKihonDto == null) {
			vo.addErrMessage(getMessage(CommonConst.MSG_NO_HUMAN_DATA, ""));
			vo.setTxtChangeKCode(kCode);
			return;
		}
		// VOに情報を設定
		vo.setFields(mKihonDto);
		vo.setMode(HumanPersonalCardVo.MODE_UPDATE);
		// セッション保持用DTO設定
		storedmKihonDto = mKihonDto;
		// 排他情報設定
		String editor = setExclusive(CommonConst.EXC_HUMAN_BASIS, user.getUserId(), kCode);
		if (editor != null) {
			vo.addErrMessage(getMessage(CommonConst.MSG_EXCLUSIVE, editor));
		}
		setNeedExclusive(true);
	}
	
	/**
	 * 個人情報取得
	 * @param kCode 取得対象社員コード
	 * @throws Exception	例外処理が発生した場合
	 */
	private void getHumanKojinInfo(String kCode) throws Exception {
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// 個人情報取得
		findHumanPersonnelInfo(kCode, false);
		// 対象データ存在確認
		if (mKojinDto == null) {
			mKojinDto = new MKojinDto();
			vo.setTxtChangeKCode(kCode);
			return;
		}
		// VOに情報を設定
		vo.setFields(mKojinDto);
		vo.setMode(HumanPersonalCardVo.MODE_UPDATE);
		// セッション保持用DTO設定
		storedmKojinDto = mKojinDto;
	}
	
	/**
	 * 緊急連絡先取得処理
	 * @param kCode 取得対象社員コード
	 * @throws Exception	例外処理が発生した場合
	 */
	private void getHumanmEmergencyInfo(String kCode) throws Exception {
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// 緊急連絡先情報取得
		findHumanEmergencyInfo(kCode, false);
		// 対象データ存在確認
		if (mEmergencyDto == null) {
			mEmergencyDto = new MEmergencyDto();
			vo.setTxtChangeKCode(kCode);
			return;
		}
		// VOに情報を設定
		vo.setFields(mEmergencyDto);
		vo.setMode(HumanPersonalCardVo.MODE_UPDATE);
		// セッション保持用DTO設定
		storedmEmergencyDto = mEmergencyDto;
	}
	
	/**
	 * セッション保持DTO取得
	 */
	@Override
	protected void getStoredDto() {
		super.getStoredDto();
		storedmKojinDto = (MKojinDto)session.getAttribute(MKojinDto.class.getName());
		storedmEmergencyDto = (MEmergencyDto)session.getAttribute(MEmergencyDto.class.getName());
	}
	
	/**
	 * セッション保持DTO設定
	 */
	@Override
	protected void setStoredDto() {
		super.setStoredDto();
		session.setAttribute(MKojinDto.class.getName(), storedmKojinDto);
		session.setAttribute(MEmergencyDto.class.getName(), storedmEmergencyDto);
	}
	
	/**
	 * 登録処理
	 * @return メッセージ
	 * @throws Exception	例外処理が発生した場合
	 */
	private String regist() throws Exception {
		HumanPersonalCardVo vo = (HumanPersonalCardVo)getVo();
		// DTOの準備
		if (mKihonDto == null) {
			mKihonDto = storedmKihonDto;
		}
		vo.setDtoFields(mKihonDto);
		if (mKojinDto == null) {
			mKojinDto = new MKojinDto();
		}
		vo.setDtoFields(mKojinDto);
		if (mEmergencyDto == null) {
			mEmergencyDto = new MEmergencyDto();
		}
		vo.setDtoFields(mEmergencyDto);
		mKojinDto.setKCode(mKihonDto.getKCode());
		// 人事基本情報存在確認
		String message = "";
		// 人事基本情報更新
		chkExclusive(mKihonDto, humanBasisDao().findForUpdate(mKihonDto.getKCode()));
		// 更新
		humanBasisDao().update(mKihonDto);
		// 個人情報取得
		MKojinDto chkMKojinDto = humanParsonalDao().findForUpdate(vo.getTxtChangeKCode());
		if (chkMKojinDto == null) {
			// 個人情報登録	
			humanParsonalDao().insert(mKojinDto);
		} else {
			// 個人情報更新
			humanParsonalDao().update(mKojinDto);
		}
		// 緊急連絡先情報取得		
		String maxEno = emergencyDao().findForMax();
		if (StringUtil.isNull(maxEno)) {
			maxEno = "-1";
		} else {
			emergencyDao().findForUpdate(maxEno);
		}
		if (emergencyDao().findForConditionUpdate(mKihonDto.getKCode()) != null) {
			storedmEmergencyDto.setDeleteFlag(1);
			// 緊急連絡先更新
			emergencyDao().update(storedmEmergencyDto);
		}
		// 最大値をセット
		mEmergencyDto.setEmCode(Integer.parseInt(maxEno) + 1);
		// 緊急連絡先登録	
		emergencyDao().insert(mEmergencyDto);
		message = getMessage(MospConst.MSG_UPDATE, "");
		return message;
	}
	
}
